LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ADD_DEC4 IS
	PORT
	(
		SA					: IN	STD_LOGIC_VECTOR(15 DOWNTO 1);
		LCD_ADD0,LCD_ADD1	: OUT 	STD_LOGIC;
		MPC_ADD0,MPC_ADD1	: OUT	STD_LOGIC;
		RE_ADD0,RE_ADD1		: OUT	STD_LOGIC;
		IRS_ADD				: OUT	STD_LOGIC;
		PTW_ADD				: OUT	STD_LOGIC;
		EV_ADD				: OUT  	STD_LOGIC;
		IOCS16n				: OUT	STD_LOGIC
	);
END ADD_DEC4;

ARCHITECTURE DATAFLOW OF ADD_DEC4 IS
BEGIN
LCD_ADD1 <= SA(1);
PROCESS (SA)
BEGIN
	CASE SA IS
		WHEN "000000010000000"
			|"000000010000001"	=>	LCD_ADD0 	<= '1';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD		<= '0';
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010001000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '1';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD		<= '0';
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010001001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '1';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD		<= '0';
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010010000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '1';
									RE_ADD1  	<= '0';
									IRS_ADD 	<= '0';								
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010010001"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '1';
									IRS_ADD  	<= '0';
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010011000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD   	<= '1';			
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';
									
		WHEN "000000010100000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD   	<= '0';	
									PTW_ADD 	<= '1';
									EV_ADD		<= '0';
									IOCS16n 	<= '1';

		WHEN "000000010101000"	=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD   	<= '0';	
									PTW_ADD 	<= '0';
									EV_ADD		<= '1';
									IOCS16n 	<= '1';

		
		WHEN OTHERS				=>	LCD_ADD0 	<= '0';
									MPC_ADD0 	<= '0';
									MPC_ADD1 	<= '0';
									RE_ADD0  	<= '0';
									RE_ADD1  	<= '0';
									IRS_ADD     <= '0';
									PTW_ADD 	<= '0';
									EV_ADD		<= '0';
									IOCS16n 	<= '0';
	END CASE;
END PROCESS;
END DATAFLOW;

