LIBRARY ieee;
USE ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;

ENTITY IRS_DEC14 IS
	PORT
	(
		IRS_IN				: IN	STD_LOGIC;
		CLK					: IN	STD_LOGIC;
		START				: IN	STD_LOGIC;
		POST				: out	STD_LOGIC_VECTOR(2 DOWNTO 0)
	);
END IRS_DEC14;

ARCHITECTURE RTL OF IRS_DEC14 IS
	SIGNAL IRS	: STD_LOGIC_VECTOR(12 DOWNTO 1);
	SIGNAL Q	: integer range 0 to 630;

BEGIN	
	
	PROCESS(CLK)
	BEGIN
		if(CLK'EVENT AND CLK = '1') then
			IF(START = '1')THEN
				Q <= 0;

			ELSE
	 			IF(Q = 6)THEN
		 			IRS(12 DOWNTO 2) <= IRS(11 DOWNTO 1);
					IRS(1) <= IRS_IN;
					Q <= Q + 1;

					IF(IRS(12 DOWNTO 7) = "111100")THEN
						CASE IRS(6 DOWNTO 1) IS
							WHEN "100000" => POST(2 DOWNTO 0) <= "001";
							WHEN "010000" => POST(2 DOWNTO 0) <= "010";
							WHEN "001000" => POST(2 DOWNTO 0) <= "011";
							WHEN "000100" => POST(2 DOWNTO 0) <= "100";
							WHEN "000010" => POST(2 DOWNTO 0) <= "101";
							WHEN OTHERS   => POST(2 DOWNTO 0) <= "000";
						END CASE;
					END IF;

				ELSIF(Q = 630)THEN
					POST(2 DOWNTO 0) <= "000";
					Q <= 0;

				ELSE
					Q <= Q + 1;
					
				End if;
			END IF;
		END IF;
	end process;
end RTL;

