LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRS_ENC3 IS
	PORT
	(
		IRS1				: IN	STD_LOGIC_VECTOR(2 DOWNTO 0);
		IRS2				: IN	STD_LOGIC_VECTOR(2 DOWNTO 0);
		IRS3				: IN	STD_LOGIC_VECTOR(2 DOWNTO 0);
		RESET				: IN	STD_LOGIC;
		B_IOWN,B_IORN		: IN	STD_LOGIC;
		IRS_ADD				: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		IRS_OUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END IRS_ENC3;

ARCHITECTURE RTL OF IRS_ENC3 IS
	SIGNAL	IRS_DUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN
	PROCESS (B_CLK,B_RESET) begin
		if(B_RESET='1')then
				IRS_DUM <= "0000000000000000";
		elsif(B_CLK'event and B_CLK='1')then
			if(B_IOWN='0' and IRS_ADD='1' and RESET='1')then
				IRS_DUM <="0000000000000000";
			elsif(B_IORN='1')then
				IRS_DUM(15) <= '0';
				IRS_DUM(14 downto 12) <= IRS1(2 DOWNTO 0);
				IRS_DUM(11) <= '0';
				IRS_DUM(10 downto 8) <= IRS2(2 DOWNTO 0);
				IRS_DUM(7) <= '0';
				IRS_DUM(6 downto 4) <= IRS3(2 DOWNTO 0);
				IRS_DUM(3 DOWNTO 0) <="1111";
			end if;
		end if;
	END PROCESS;
IRS_OUT <= IRS_DUM;
END RTL;

