LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY PTW_LATCH IS
	PORT
	(
		WLSIN				: IN	STD_LOGIC_VECTOR(5 DOWNTO 0);
		TSIN				: IN	STD_LOGIC_VECTOR(7 DOWNTO 0);
		POIN,RESET			: IN	STD_LOGIC;
		B_IOWN,B_IORN		: IN	STD_LOGIC;
		PTW_ADD				: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		PTWOUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END PTW_LATCH;

ARCHITECTURE RTL OF PTW_LATCH IS
	SIGNAL	PTWDUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN
	PROCESS (B_CLK,B_RESET) begin
		if(B_RESET='1')then
				PTWDUM <= "0000000000000000";
		elsif(B_CLK'event and B_CLK='1')then
			if(B_IOWN='0' and PTW_ADD='1' and RESET='1')then
				PTWDUM <="0000000000000000";
			elsif(B_IORN='1')then
				PTWDUM(15) <= POIN;
				PTWDUM(14 downto 7) <= TSIN;
				PTWDUM(6 downto 1) <= WLSIN;
				PTWDUM(0) <= '0';
			end if;
		end if;
	END PROCESS;
PTWOUT <= PTWDUM;
END RTL;

