LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

ENTITY PWM5 IS
	PORT
	(
		R_DATA	: IN	STD_LOGIC_VECTOR(6 downto 0);
		L_DATA	: IN	STD_LOGIC_VECTOR(6 downto 0);
		CLK		: IN	STD_LOGIC;
		Tout_R	: OUT 	STD_LOGIC;
		Tout_L	: OUT 	STD_LOGIC);
END PWM5;

ARCHITECTURE RTL OF PWM5 IS
SIGNAL Q : integer range 0 to 127;
BEGIN
	PROCESS (CLK,Q)
	BEGIN
		IF(CLK'EVENT AND CLK = '1')THEN
			if (Q = 127) then
				Q <= 0;
			else
				Q <= Q + 1;
			end if;


			if (Q < L_DATA) then
				Tout_L <= '0';
			else
				Tout_L <= '1';
			end if;

			if (Q < R_DATA) then
				Tout_R <= '0';
			else
				Tout_R <= '1';
			end if;
		END IF;
	END PROCESS;
	END RTL;

